Send patches - preferably formatted by git format-patch - to patches at archlinux32 dot org.
summaryrefslogtreecommitdiff
path: root/src
diff options
context:
space:
mode:
authorLevente Polyak <anthraxx@archlinux.org>2022-10-23 20:42:34 +0200
committerLevente Polyak <anthraxx@archlinux.org>2023-05-19 22:27:12 +0200
commit77d800eab2419b334cafd94b2e986351919def77 (patch)
treea4d38ebe249052ec926c59ad970440845055fef7 /src
parentd2245b1943fd30ab0252e47d47871ac94e143339 (diff)
auth: implemented module to authenticate against our GitLab
This helps to have a convenient way to manage and test our personal GitLab tokens. Those are used for certain API calls like creating new repositories. prefill the access token web view as per https://docs.gitlab.com/ee/user/profile/personal_access_tokens.html#prefill-personal-access-token-name-and-scopes Signed-off-by: Levente Polyak <anthraxx@archlinux.org>
Diffstat (limited to 'src')
-rw-r--r--src/lib/auth.sh72
-rw-r--r--src/lib/auth/login.sh93
-rw-r--r--src/lib/auth/status.sh69
-rw-r--r--src/pkgctl.in9
4 files changed, 243 insertions, 0 deletions
diff --git a/src/lib/auth.sh b/src/lib/auth.sh
new file mode 100644
index 0000000..77d6a90
--- /dev/null
+++ b/src/lib/auth.sh
@@ -0,0 +1,72 @@
+#!/hint/bash
+#
+# This may be included with or without `set -euE`
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_AUTH_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_AUTH_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+
+set -e
+
+
+pkgctl_auth_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [COMMAND] [OPTIONS]
+
+ Authenticate with services like GitLab.
+
+ COMMANDS
+ login Authenticate with the GitLab instance
+ status View authentication status
+
+ OPTIONS
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND} login --gen-access-token
+ $ ${COMMAND} status
+_EOF_
+}
+
+pkgctl_auth() {
+ if (( $# < 1 )); then
+ pkgctl_auth_usage
+ exit 0
+ fi
+
+ # option checking
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_auth_usage
+ exit 0
+ ;;
+ login)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/auth/login.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/auth/login.sh
+ pkgctl_auth_login "$@"
+ exit 0
+ ;;
+ status)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/auth/status.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/auth/status.sh
+ pkgctl_auth_status "$@"
+ exit 0
+ ;;
+ -*)
+ die "invalid argument: %s" "$1"
+ ;;
+ *)
+ die "invalid command: %s" "$1"
+ ;;
+ esac
+ done
+}
diff --git a/src/lib/auth/login.sh b/src/lib/auth/login.sh
new file mode 100644
index 0000000..083e80a
--- /dev/null
+++ b/src/lib/auth/login.sh
@@ -0,0 +1,93 @@
+#!/hint/bash
+#
+# This may be included with or without `set -euE`
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_AUTH_LOGIN_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_AUTH_LOGIN_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+# shellcheck source=src/lib/common.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/common.sh
+# shellcheck source=src/lib/config.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/config.sh
+# shellcheck source=src/lib/api/gitlab.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/api/gitlab.sh
+
+set -e
+
+
+pkgctl_auth_login_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [OPTIONS]
+
+ Interactively authenticate with the GitLab instance.
+
+ The minimum required scopes for the token are: 'api', 'write_repository'.
+
+ OPTIONS
+ -g, --gen-access-token Open the URL to generate a new personal access token
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND}
+ $ ${COMMAND} --gen-access-token
+_EOF_
+}
+
+
+pkgctl_auth_login() {
+ local token personal_access_token_url
+ local GEN_ACESS_TOKEN=0
+
+ # option checking
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_auth_login_usage
+ exit 0
+ ;;
+ -g|--gen-access-token)
+ GEN_ACESS_TOKEN=1
+ shift
+ ;;
+ *)
+ die "invalid argument: %s" "$1"
+ ;;
+ esac
+ done
+
+ personal_access_token_url="https://${GITLAB_HOST}/-/profile/personal_access_tokens?name=pkgctl+token&scopes=api,write_repository"
+
+ cat <<- _EOF_
+ Logging into ${BOLD}${GITLAB_HOST}${ALL_OFF}
+
+ Tip: you can generate a Personal Access Token here ${personal_access_token_url}
+ The minimum required scopes are 'api' and 'write_repository'.
+_EOF_
+
+ if (( GEN_ACESS_TOKEN )); then
+ xdg-open "${personal_access_token_url}" 2>/dev/null
+ fi
+
+ # read token from stdin
+ read -s -r -p "${GREEN}?${ALL_OFF} ${BOLD}Paste your authentication token:${ALL_OFF} " token
+ echo
+
+ if [[ -z ${token} ]]; then
+ msg_error " No token provided"
+ exit 1
+ fi
+
+ # check if the passed token works
+ GITLAB_TOKEN="${token}"
+ if ! result=$(gitlab_api_get_user); then
+ printf "%s\n" "$result"
+ exit 1
+ fi
+
+ msg_success " Logged in as ${BOLD}${result}${ALL_OFF}"
+ save_devtools_config
+}
diff --git a/src/lib/auth/status.sh b/src/lib/auth/status.sh
new file mode 100644
index 0000000..6cbaab1
--- /dev/null
+++ b/src/lib/auth/status.sh
@@ -0,0 +1,69 @@
+#!/hint/bash
+#
+# This may be included with or without `set -euE`
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_AUTH_STATUS_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_AUTH_STATUS_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+# shellcheck source=src/lib/common.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/common.sh
+# shellcheck source=src/lib/api/gitlab.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/api/gitlab.sh
+
+set -e
+
+
+pkgctl_auth_status_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [OPTIONS]
+
+ Verifies and displays information about your authentication state of
+ services like the GitLab instance and reports issues if any.
+
+ OPTIONS
+ -t, --show-token Display the auth token
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND}
+ $ ${COMMAND} --show-token
+_EOF_
+}
+
+pkgctl_auth_status() {
+ local SHOW_TOKEN=0
+ # option checking
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_auth_status_usage
+ exit 0
+ ;;
+ -t|--show-token)
+ SHOW_TOKEN=1
+ shift
+ ;;
+ *)
+ die "invalid argument: %s" "$1"
+ ;;
+ esac
+ done
+
+ printf "%s\n" "${BOLD}${GITLAB_HOST}${ALL_OFF}"
+ # shellcheck disable=2119
+ if ! username=$(gitlab_api_get_user); then
+ printf "%s\n" "${username}"
+ exit 1
+ fi
+
+ msg_success " Logged in as ${BOLD}${username}${ALL_OFF}"
+ if (( SHOW_TOKEN )); then
+ msg_success " Token: ${GITLAB_TOKEN}"
+ else
+ msg_success " Token: **************************"
+ fi
+}
diff --git a/src/pkgctl.in b/src/pkgctl.in
index 35305c1..e024d1f 100644
--- a/src/pkgctl.in
+++ b/src/pkgctl.in
@@ -19,6 +19,7 @@ usage() {
Unified command-line frontend for devtools.
COMMANDS
+ auth Authenticate with services like GitLab
diff Compare package files using different modes
repo Manage Git packaging repositories and their configuration
@@ -51,6 +52,14 @@ while (( $# )); do
pkgctl_repo "$@"
exit 0
;;
+ auth)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/auth.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/auth.sh
+ pkgctl_auth "$@"
+ exit 0
+ ;;
diff)
_DEVTOOLS_COMMAND+=" $1"
shift